<?php

namespace Drupal\enforce_user_fields\EventSubscriber;

use Drupal\Core\Messenger\MessengerInterface;
use Drupal\Core\Url;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;

/**
 * Class EnforceUserFieldsSubscriber.
 */
class EnforceUserFieldsSubscriber implements EventSubscriberInterface {


  public function checkForUserFields(GetResponseEvent $event) {
    $user = \Drupal::currentUser();
    $route_name = \Drupal::routeMatch()->getRouteName();
    if ($user->isAnonymous() || enforce_user_fields_user_has_admin_role($user) || ($route_name == 'entity.user.edit_form')) {
      return;
    }
    if (!empty($_SESSION['enforce_user_fields'])) {
      \Drupal::messenger()->addMessage(t('You need fill required fields before proceed'), MessengerInterface::TYPE_ERROR);
      $event->setResponse(new RedirectResponse(Url::fromRoute('entity.user.edit_form', ['user' => $user->id()])->toString()));
    }
  }

  /**
   * {@inheritdoc}
   */
  static function getSubscribedEvents() {
    $events[KernelEvents::REQUEST][] = array('checkForUserFields');
    return $events;
  }


}
